/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import org.apache.commons.lang.StringUtils;

import com.trg.search.Filter;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.util.Clients;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Textbox;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.entidad.Nodo;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PtovtaEmpresa;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.entidad.TipoPuntoVenta;
import com.rjconsultores.ventaboletos.service.CiudadService;
import com.rjconsultores.ventaboletos.service.MonedaService;
import com.rjconsultores.ventaboletos.service.NodoService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.TipoPuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxCiudad;
import com.rjconsultores.ventaboletos.web.utilerias.MyComboboxParada;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderPuntoVenta;
import com.rjconsultores.ws.utileria.RetornoTotvs.TipoRetorno;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaPuntoVentaController")
@Scope("prototype")
public class BusquedaPuntoVentaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<PuntoVenta> plwPuntoVenta;
	@Autowired
	private TipoPuntoVentaService tipoPuntoVentaService;
	@Autowired
	private MonedaService monedaService;
	@Autowired
	private NodoService nodoService;
	
	private MyListbox puntoVentaList;
	private Paging pagingPuntoVenta;
	private Textbox txtNombre;
	private Textbox txtNumeroPtoVenta;
	private Textbox txtCalle;
	private Textbox txtNumero;
	private Textbox txtColonia;
	private Textbox txtTelefonoUno;
	private Textbox txtTelefonoDos;
	private Textbox txtNumDocPuntoVenta;
	private List<Empresa> lsEmpresas;
	private List<TipoPuntoVenta> lsTipoPuntoVenta;
	private List<Moneda> lsMoneda;
	private List<Nodo> lsNodos;
	private Combobox cmbEmpresa;
	private Combobox cmbTipoPontoVenta;
	private Combobox cmbMoneda;
	private Combobox cmbNodo;
	private MyComboboxCiudad cmbCidade;	
	private MyComboboxParada cmbLocalidade;
	private Radio radAprobacionAutorizado;
	private Radio radAprobacionLatente;
	private Radio radTotvsSi;
	private Radio radTotvsNo;
	private boolean integracionTotvs;
	
	public boolean isIntegracionTotvs() {
		integracionTotvs = false;
		if (ApplicationProperties.getInstance().integracionTotvs()) {
			integracionTotvs = true;
		}
		return integracionTotvs;
	}
	
	public void setIntegracionTotvs(boolean integracionTotvs) {
		this.integracionTotvs = integracionTotvs;
	}

	public Radio getRadAprobacionAutorizado() {
		return radAprobacionAutorizado;
	}

	public void setRadAprobacionAutorizado(Radio radAprobacionAutorizado) {
		this.radAprobacionAutorizado = radAprobacionAutorizado;
	}

	public Radio getRadAprobacionLatente() {
		return radAprobacionLatente;
	}

	public void setRadAprobacionLatente(Radio radAprobacionLatente) {
		this.radAprobacionLatente = radAprobacionLatente;
	}

	public Combobox getCmbEmpresa() {
		return cmbEmpresa;
	}

	public void setCmbEmpresa(Combobox cmbEmpresa) {
		this.cmbEmpresa = cmbEmpresa;
	}

	public Combobox getCmbMoneda() {
		return cmbMoneda;
	}

	public void setCmbMoneda(Combobox cmbMoneda) {
		this.cmbMoneda = cmbMoneda;
	}

	public Combobox getCmbNodo() {
		return cmbNodo;
	}

	public void setCmbNodo(Combobox cmbNodo) {
		this.cmbNodo = cmbNodo;
	}

	public Combobox getCmbTipoPontoVenta() {
		return cmbTipoPontoVenta;
	}

	public void setCmbTipoPontoVenta(Combobox cmbTipoPontoVenta) {
		this.cmbTipoPontoVenta = cmbTipoPontoVenta;
	}
	
	public MyComboboxParada getCmbLocalidade() {
		return cmbLocalidade;
	}

	public void setCmbLocalidade(MyComboboxParada cmbLocalidade) {
		this.cmbLocalidade = cmbLocalidade;
	}

	public MyComboboxCiudad getCmbCidade() {
		return cmbCidade;
	}

	public void setCmbCidade(MyComboboxCiudad cmbCidade) {
		this.cmbCidade = cmbCidade;
	}

	public Textbox getTxtNombre() {
		return txtNombre;
	}

	public void setTxtNombre(Textbox txtNombre) {
		this.txtNombre = txtNombre;
	}

	public Paging getPagingPuntoVenta() {
		return pagingPuntoVenta;
	}

	public void setPagingPuntoVenta(Paging pagingPuntoVenta) {
		this.pagingPuntoVenta = pagingPuntoVenta;
	}

	public MyListbox getPuntoVentaList() {
		return puntoVentaList;
	}

	public void setPuntoVentaList(MyListbox puntoVentaList) {
		this.puntoVentaList = puntoVentaList;
	}

	public PagedListWrapper<PuntoVenta> getPlwPuntoVenta() {
		return plwPuntoVenta;
	}

	public void setPlwPuntoVenta(PagedListWrapper<PuntoVenta> plwPuntoVenta) {
		this.plwPuntoVenta = plwPuntoVenta;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new PuntoVenta());
	}

	public List<Empresa> getLsEmpresas() {
		return lsEmpresas;
	}

	public void setLsEmpresas(List<Empresa> lsEmpresas) {
		this.lsEmpresas = lsEmpresas;
	}

	public List<Moneda> getLsMoneda() {
		return lsMoneda;
	}

	public void setLsMoneda(List<Moneda> lsMoneda) {
		this.lsMoneda = lsMoneda;
	}

	public List<Nodo> getLsNodos() {
		return lsNodos;
	}

	public void setLsNodos(List<Nodo> lsNodos) {
		this.lsNodos = lsNodos;
	}

	public List<TipoPuntoVenta> getLsTipoPuntoVenta() {
		return lsTipoPuntoVenta;
	}

	public void setLsTipoPuntoVenta(List<TipoPuntoVenta> lsTipoPuntoVenta) {
		this.lsTipoPuntoVenta = lsTipoPuntoVenta;
	}
	

	public void aplicarMascara() {
		Clients.evalJavaScript("jQuery('#" + txtTelefonoUno.getUuid()
				+ "').mask('(999)9999-9999?9');jQuery('#" + txtTelefonoDos.getUuid()
				+ "').mask('(999)9999-9999?9')");
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);
		aplicarMascara();
		lsEmpresas = UsuarioLogado.getUsuarioLogado().getEmpresa();
		lsTipoPuntoVenta = tipoPuntoVentaService.obtenerTodos();
		lsMoneda = monedaService.obtenerTodos();
		lsNodos = nodoService.obtenerTodos();
		puntoVentaList.setItemRenderer(new RenderPuntoVenta());
		puntoVentaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				PuntoVenta c = (PuntoVenta) puntoVentaList.getSelected();
				verPeriodo(c);
			}
		});

		refreshLista();
		txtNombre.focus();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verPeriodo(PuntoVenta c) {
		if (c == null) {
			return;
		}

		Map args = new HashMap();
		args.put("puntoVenta", c);
		args.put("puntoVentaList", puntoVentaList);

		openWindow("/gui/catalogos/editarPuntoVenta.zul",
				Labels.getLabel("editarPuntoVentaController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<PuntoVenta> claseServicioBusqueda = new HibernateSearchObject<PuntoVenta>(PuntoVenta.class, pagingPuntoVenta.getPageSize());

		claseServicioBusqueda.addFilterLike("nombpuntoventa", "%" + txtNombre.getText().trim().concat("%"));

		Comboitem itemEmpresa = cmbEmpresa.getSelectedItem();
		Comboitem itemTipoPontoVenta = cmbTipoPontoVenta.getSelectedItem();
		Comboitem itemMoneda = cmbMoneda.getSelectedItem();
		Comboitem itemNodo = cmbNodo.getSelectedItem();
		Comboitem itemLocalidade = cmbLocalidade.getSelectedItem();
		Comboitem itemCidade = cmbCidade.getSelectedItem();

		Empresa empresa;
		TipoPuntoVenta tipoPontoVenta;
		Moneda moneda;
		Nodo nodo;
		Parada parada;
		Ciudad cidade;

		if (!txtNumeroPtoVenta.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("numPuntoVenta", "%" + txtNumeroPtoVenta.getText().trim().concat("%"));
		}

		List<Integer> lsIntegracion = new ArrayList<Integer>();
		lsIntegracion.add(1);
		lsIntegracion.add(2);
		
		if (radTotvsSi.isChecked()){
			claseServicioBusqueda.addFilterIn("indIntegracion", lsIntegracion);
		}
		
		if (radTotvsNo.isChecked()){
			claseServicioBusqueda.addFilterEqual("indIntegracion", -1);
			claseServicioBusqueda.addFilterOr(Filter.equal("indIntegracion", -1), 
					Filter.isNull("indIntegracion"), Filter.equal("indIntegracion",0));
		}
		
		String statusAprobacion = null;
		if (radAprobacionAutorizado.isChecked()) {
			statusAprobacion = "A";
		} else if (radAprobacionLatente.isChecked()) {
			statusAprobacion = "L";
		}

		if (statusAprobacion != null) {
			claseServicioBusqueda.addFilterEqual("statusaprobacion", statusAprobacion);
		}

		if (itemEmpresa != null) {
			empresa = (Empresa) itemEmpresa.getValue();
			claseServicioBusqueda.addFilterEqual("lsPtovtaEmpresa.empresa", empresa);
		} else {
			claseServicioBusqueda.addFilterOr(Filter.in("lsPtovtaEmpresa.empresa", lsEmpresas), Filter.isEmpty("lsPtovtaEmpresa"));
		}

		
		if (itemTipoPontoVenta != null) {
			tipoPontoVenta = (TipoPuntoVenta) itemTipoPontoVenta.getValue();
			claseServicioBusqueda.addFilterEqual("tipoPuntoVenta", tipoPontoVenta);
		}

		if (itemMoneda != null) {
			moneda = (Moneda) itemMoneda.getValue();
			claseServicioBusqueda.addFilterEqual("moneda", moneda);
		}

		if (itemNodo != null) {
			nodo = (Nodo) itemNodo.getValue();
			claseServicioBusqueda.addFilterEqual("nodo", nodo);
		}
		
		if(itemLocalidade != null){
			parada = (Parada) itemLocalidade.getValue();
			claseServicioBusqueda.addFilterEqual("parada", parada);
		}
		
		if(itemCidade != null){
			cidade = (Ciudad) itemCidade.getValue();
			claseServicioBusqueda.addFilterEqual("colonia.ciudad",cidade);
		}

		if (!txtCalle.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("direccioncalle", txtCalle.getText());
		}

		if (!txtNumero.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("direccionnumero", txtNumero.getText());
		}

		if (!txtColonia.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("direccioncolonia", txtColonia.getText());
		}

		if (!txtTelefonoUno.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("numtelefonouno", txtTelefonoUno.getText().replace("_", ""));
		}

		if (!txtTelefonoDos.getText().isEmpty()) {
			claseServicioBusqueda.addFilterLike("numtelefonodos", txtTelefonoDos.getText().replace("_", ""));
		}
		
		if (StringUtils.isNotBlank(txtNumDocPuntoVenta.getText())) {
			claseServicioBusqueda.addFilterLike("numDoCPuntoVenta", txtNumDocPuntoVenta.getText().trim().concat("%"));
		}

		claseServicioBusqueda.addFilterEqual("activo", Boolean.TRUE);
		claseServicioBusqueda.addSortAsc("nombpuntoventa");
		claseServicioBusqueda.addFilterNotEqual("puntoventaId", -1);
		claseServicioBusqueda.setDistinct(Boolean.TRUE);

		plwPuntoVenta.init(claseServicioBusqueda, puntoVentaList, pagingPuntoVenta);

		if (puntoVentaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaPuntoVentaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
}
